/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.permissions;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.dto.permissions.RepositoryPermission;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class SinglePermissionRecipientRequestAdapter
/*    */   extends AbstractAdapter
/*    */ {
/*    */   private final String resourceUri;
/*    */   private final String recipient;
/*    */   
/*    */   public SinglePermissionRecipientRequestAdapter(SessionStorage sessionStorage, String resourceUri, String recipient)
/*    */   {
/* 35 */     super(sessionStorage);
/* 36 */     this.resourceUri = resourceUri;
/* 37 */     this.recipient = recipient;
/*    */   }
/*    */   
/*    */   public OperationResult<RepositoryPermission> get() {
/* 41 */     return getBuilder(RepositoryPermission.class).get();
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncGet(final Callback<OperationResult<RepositoryPermission>, R> callback) {
/* 45 */     final JerseyRequest<RepositoryPermission> request = getBuilder(RepositoryPermission.class);
/* 46 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 49 */         callback.execute(request.get());
/*    */       }
/* 51 */     });
/* 52 */     ThreadPoolUtil.runAsynchronously(task);
/* 53 */     return task;
/*    */   }
/*    */   
/*    */   public OperationResult<RepositoryPermission> createOrUpdate(RepositoryPermission permission) {
/* 57 */     return getBuilder(RepositoryPermission.class).put(permission);
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncCreateOrUpdate(final RepositoryPermission permission, final Callback<OperationResult<RepositoryPermission>, R> callback) {
/* 61 */     final JerseyRequest<RepositoryPermission> request = getBuilder(RepositoryPermission.class);
/* 62 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 65 */         callback.execute(request.put(permission));
/*    */       }
/* 67 */     });
/* 68 */     ThreadPoolUtil.runAsynchronously(task);
/* 69 */     return task;
/*    */   }
/*    */   
/*    */   public OperationResult delete() {
/* 73 */     return getBuilder(Object.class).delete();
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncDelete(final Callback<OperationResult, R> callback) {
/* 77 */     final JerseyRequest request = getBuilder(Object.class);
/* 78 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 81 */         callback.execute(request.delete());
/*    */       }
/* 83 */     });
/* 84 */     ThreadPoolUtil.runAsynchronously(task);
/* 85 */     return task;
/*    */   }
/*    */   
/*    */   private <T> JerseyRequest<T> getBuilder(Class<T> responseClass) {
/* 89 */     JerseyRequest<T> request = JerseyRequest.buildRequest(this.sessionStorage, responseClass, new String[] { "/permissions", this.resourceUri });
/* 90 */     request.addMatrixParam("recipient", new String[] { this.recipient });
/* 91 */     return request;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\permissions\SinglePermissionRecipientRequestAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */