/*     */ package com.jaspersoft.jasperserver.jaxrs.client.core;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.attributes.ServerAttributesService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.organizations.OrganizationsService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.roles.RolesService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.users.UsersService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.domain.DomainMetadataService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.importexport.exportservice.ExportService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.importexport.importservice.ImportService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.jobs.JobsService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.permissions.PermissionsService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.query.QueryExecutorService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.reporting.ReportingService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.resources.ResourcesService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.serverInfo.ServerInfoService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.settings.SettingsService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.thumbnails.ThumbnailsService;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*     */ import java.lang.reflect.Constructor;
/*     */ import javax.ws.rs.client.Invocation.Builder;
/*     */ import javax.ws.rs.client.WebTarget;
/*     */ import javax.ws.rs.core.Response;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class Session
/*     */ {
/*     */   private SessionStorage storage;
/*     */   
/*     */   public Session(SessionStorage sessionStorage)
/*     */   {
/*  49 */     this.storage = sessionStorage;
/*     */   }
/*     */   
/*     */   public SessionStorage getStorage() {
/*  53 */     return this.storage;
/*     */   }
/*     */   
/*     */   public void logout() {
/*  57 */     WebTarget target = this.storage.getRootTarget().path("/exituser.html");
/*  58 */     Response response = target.request().get();
/*  59 */     if (response.getStatus() >= 400) {
/*  60 */       new DefaultErrorHandler().handleError(response);
/*     */     }
/*     */   }
/*     */   
/*     */   public <ServiceType extends AbstractAdapter> ServiceType getService(Class<ServiceType> serviceClass) {
/*     */     try {
/*  66 */       return (AbstractAdapter)serviceClass.getConstructor(new Class[] { SessionStorage.class }).newInstance(new Object[] { this.storage });
/*     */     } catch (Exception e) {
/*  68 */       throw new RuntimeException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public OrganizationsService organizationsService() {
/*  73 */     return (OrganizationsService)getService(OrganizationsService.class);
/*     */   }
/*     */   
/*     */   public ServerInfoService serverInfoService() {
/*  77 */     return (ServerInfoService)getService(ServerInfoService.class);
/*     */   }
/*     */   
/*     */   public UsersService usersService() {
/*  81 */     return (UsersService)getService(UsersService.class);
/*     */   }
/*     */   
/*     */   public RolesService rolesService() {
/*  85 */     return (RolesService)getService(RolesService.class);
/*     */   }
/*     */   
/*     */   public PermissionsService permissionsService() {
/*  89 */     return (PermissionsService)getService(PermissionsService.class);
/*     */   }
/*     */   
/*     */   public ExportService exportService() {
/*  93 */     return (ExportService)getService(ExportService.class);
/*     */   }
/*     */   
/*     */   public ImportService importService() {
/*  97 */     return (ImportService)getService(ImportService.class);
/*     */   }
/*     */   
/*     */   public ReportingService reportingService() {
/* 101 */     return (ReportingService)getService(ReportingService.class);
/*     */   }
/*     */   
/*     */   public ResourcesService resourcesService() {
/* 105 */     return (ResourcesService)getService(ResourcesService.class);
/*     */   }
/*     */   
/*     */   public JobsService jobsService() {
/* 109 */     return (JobsService)getService(JobsService.class);
/*     */   }
/*     */   
/*     */   public DomainMetadataService domainService() {
/* 113 */     return (DomainMetadataService)getService(DomainMetadataService.class);
/*     */   }
/*     */   
/*     */   public QueryExecutorService queryExecutorService() {
/* 117 */     return (QueryExecutorService)getService(QueryExecutorService.class);
/*     */   }
/*     */   
/*     */   public ThumbnailsService thumbnailsService() {
/* 121 */     return (ThumbnailsService)getService(ThumbnailsService.class);
/*     */   }
/*     */   
/*     */   public ServerAttributesService serverAttributesService() {
/* 125 */     return (ServerAttributesService)getService(ServerAttributesService.class);
/*     */   }
/*     */   
/*     */   public SettingsService settingsService() {
/* 129 */     return (SettingsService)getService(SettingsService.class);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\core\Session.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */