/*     */ package com.jaspersoft.jasperserver.jaxrs.client.dto.common;
/*     */ 
/*     */ import java.util.Arrays;
/*     */ import java.util.LinkedList;
/*     */ import java.util.List;
/*     */ import javax.xml.bind.annotation.XmlElement;
/*     */ import javax.xml.bind.annotation.XmlElementWrapper;
/*     */ import javax.xml.bind.annotation.XmlRootElement;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ @XmlRootElement
/*     */ public class ErrorDescriptor
/*     */ {
/*     */   public static final String ERROR_CODE_UNEXPECTED_ERROR = "unexpected.error";
/*     */   private String message;
/*     */   private String errorCode;
/*     */   private String[] parameters;
/*     */   
/*     */   public ErrorDescriptor() {}
/*     */   
/*     */   public ErrorDescriptor(Throwable cause)
/*     */   {
/*  44 */     this.errorCode = "unexpected.error";
/*  45 */     this.message = "Unexpected error";
/*  46 */     this.parameters = new String[] { cause.getClass().getName() + ((cause.getMessage() != null) && (!"".equals(cause.getMessage())) ? ": " + cause.getMessage() : "") };
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public String getMessage()
/*     */   {
/*  53 */     return this.message;
/*     */   }
/*     */   
/*     */   public void setMessage(String message) {
/*  57 */     this.message = message;
/*     */   }
/*     */   
/*     */   public String getErrorCode() {
/*  61 */     return this.errorCode;
/*     */   }
/*     */   
/*     */   public void setErrorCode(String errorCode) {
/*  65 */     this.errorCode = errorCode;
/*     */   }
/*     */   
/*     */   @XmlElementWrapper(name="parameters")
/*     */   @XmlElement(name="parameter")
/*  70 */   public String[] getParameters() { return this.parameters; }
/*     */   
/*     */   public void setParameters(String... parameters)
/*     */   {
/*  74 */     this.parameters = parameters;
/*     */   }
/*     */   
/*     */   public void setParameters(Object... args) {
/*  78 */     if ((args != null) && (args.length > 0)) {
/*  79 */       List<String> values = new LinkedList();
/*  80 */       for (Object arg : args) {
/*  81 */         if (arg != null) {
/*  82 */           values.add(arg.toString());
/*     */         }
/*     */       }
/*  85 */       if (!values.isEmpty()) {
/*  86 */         this.parameters = ((String[])values.toArray(new String[values.size()]));
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public boolean equals(Object o)
/*     */   {
/*  93 */     if (this == o) return true;
/*  94 */     if ((o == null) || (getClass() != o.getClass())) { return false;
/*     */     }
/*  96 */     ErrorDescriptor that = (ErrorDescriptor)o;
/*     */     
/*  98 */     if (this.errorCode != null ? !this.errorCode.equals(that.errorCode) : that.errorCode != null) return false;
/*  99 */     if (this.message != null ? !this.message.equals(that.message) : that.message != null) return false;
/* 100 */     if (!Arrays.equals(this.parameters, that.parameters)) { return false;
/*     */     }
/* 102 */     return true;
/*     */   }
/*     */   
/*     */   public int hashCode()
/*     */   {
/* 107 */     int result = this.message != null ? this.message.hashCode() : 0;
/* 108 */     result = 31 * result + (this.errorCode != null ? this.errorCode.hashCode() : 0);
/* 109 */     result = 31 * result + (this.parameters != null ? Arrays.hashCode(this.parameters) : 0);
/* 110 */     return result;
/*     */   }
/*     */   
/*     */   public String toString()
/*     */   {
/* 115 */     return "ErrorDescriptor{message='" + this.message + '\'' + ", errorCode='" + this.errorCode + '\'' + ", parameters=" + (this.parameters == null ? null : Arrays.asList(this.parameters)) + '}';
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static class Builder
/*     */   {
/* 123 */     private ErrorDescriptor errorDescriptor = new ErrorDescriptor();
/*     */     
/*     */     public Builder setMessage(String message) {
/* 126 */       this.errorDescriptor.setMessage(message);
/* 127 */       return this;
/*     */     }
/*     */     
/*     */     public Builder setErrorCode(String errorCode) {
/* 131 */       this.errorDescriptor.setErrorCode(errorCode);
/* 132 */       return this;
/*     */     }
/*     */     
/*     */     public Builder setParameters(String... parameters) {
/* 136 */       this.errorDescriptor.setParameters(parameters);
/* 137 */       return this;
/*     */     }
/*     */     
/*     */     public Builder setParameters(Object... args) {
/* 141 */       this.errorDescriptor.setParameters(args);
/* 142 */       return this;
/*     */     }
/*     */     
/*     */     public ErrorDescriptor getErrorDescriptor() {
/* 146 */       return this.errorDescriptor;
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\dto\common\ErrorDescriptor.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */