/*     */ package com.jaspersoft.jasperserver.ws.scheduling;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.ws.util.ResourceConfigurationProvider;
/*     */ import java.net.URL;
/*     */ import java.rmi.RemoteException;
/*     */ import java.util.Calendar;
/*     */ import java.util.Locale;
/*     */ import javax.xml.rpc.ServiceException;
/*     */ import org.apache.axis.EngineConfiguration;
/*     */ import org.apache.axis.client.Stub;
/*     */ import org.apache.axis.message.SOAPHeaderElement;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ReportSchedulerFacade
/*     */   implements ReportScheduler
/*     */ {
/*     */   private static final String NAMESPACE = "http://www.jasperforge.org/jasperserver/ws";
/*     */   private static final String HEADER_LOCALE = "locale";
/*     */   private static final String AXIS_CONFIGURATION_RESOURCE = "/com/jaspersoft/jasperserver/ws/scheduling/client-config.wsdd";
/*     */   private final ReportSchedulerSoapBindingStub service;
/*     */   
/*     */   public ReportSchedulerFacade(URL address, String user, String password)
/*     */     throws ServiceException
/*     */   {
/*  60 */     this.service = createServiceStub(address, user, password);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReportSchedulerFacade(ReportSchedulerSoapBindingStub serviceStub)
/*     */   {
/*  69 */     this.service = serviceStub;
/*     */   }
/*     */   
/*     */   protected ReportSchedulerSoapBindingStub createServiceStub(URL address, String user, String password) throws ServiceException {
/*  73 */     ReportSchedulerServiceLocator locator = new ReportSchedulerServiceLocator(getEngineConfiguration());
/*  74 */     ReportSchedulerSoapBindingStub stub = (ReportSchedulerSoapBindingStub)locator.getReportScheduler(address);
/*     */     
/*  76 */     stub.setUsername(user);
/*  77 */     stub.setPassword(password);
/*  78 */     stub.setMaintainSession(true);
/*     */     
/*  80 */     return stub;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setLocale(Locale locale)
/*     */   {
/*  91 */     setLocale(locale.toString());
/*     */   }
/*     */   
/*     */   protected void setLocale(String locale) {
/*  95 */     SOAPHeaderElement localeHeader = new SOAPHeaderElement("http://www.jasperforge.org/jasperserver/ws", "locale", locale);
/*  96 */     localeHeader.setActor(null);
/*  97 */     this.service.setHeader(localeHeader);
/*     */   }
/*     */   
/*     */   protected EngineConfiguration getEngineConfiguration() {
/* 101 */     return new ResourceConfigurationProvider("/com/jaspersoft/jasperserver/ws/scheduling/client-config.wsdd");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public void deleteJob(long id)
/*     */     throws RemoteException
/*     */   {
/* 110 */     this.service.deleteJob(id);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public void deleteJobs(long[] ids)
/*     */     throws RemoteException
/*     */   {
/* 119 */     this.service.deleteJobs(ids);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JobSummary[] getAllJobs()
/*     */     throws RemoteException
/*     */   {
/* 131 */     return this.service.getAllJobs();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Job getJob(long id)
/*     */     throws RemoteException
/*     */   {
/* 141 */     return processJob(this.service.getJob(id));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JobSummary[] getReportJobs(String reportURI)
/*     */     throws RemoteException
/*     */   {
/* 155 */     return this.service.getReportJobs(reportURI);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Job scheduleJob(Job job)
/*     */     throws RemoteException
/*     */   {
/* 166 */     return processJob(this.service.scheduleJob(job));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Job updateJob(Job job)
/*     */     throws RemoteException
/*     */   {
/* 177 */     return processJob(this.service.updateJob(job));
/*     */   }
/*     */   
/*     */   protected Job processJob(Job job) {
/* 181 */     if (job != null) {
/* 182 */       processJobParameters(job);
/*     */     }
/* 184 */     return job;
/*     */   }
/*     */   
/*     */   protected void processJobParameters(Job job) {
/* 188 */     JobParameter[] parameters = job.getParameters();
/* 189 */     if (parameters != null) {
/* 190 */       for (int i = 0; i < parameters.length; i++) {
/* 191 */         JobParameter parameter = parameters[i];
/* 192 */         processJobParameter(parameter);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   protected void processJobParameter(JobParameter parameter) {
/* 198 */     Object value = parameter.getValue();
/* 199 */     if ((value instanceof Calendar)) {
/* 200 */       parameter.setValue(((Calendar)value).getTime());
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-ireport-plugin-2.0.1.jar!\com\jaspersoft\jasperserver\ws\scheduling\ReportSchedulerFacade.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */