/*     */ package com.netapp.asup.cache.LRU;
/*     */ 
/*     */ import com.netapp.asup.util.CacheUtils;
/*     */ import java.util.concurrent.atomic.AtomicLong;
/*     */ 
/*     */ 
/*     */ 
/*     */ public class AsupLRUCacheStats
/*     */ {
/*  10 */   protected final AtomicLong hitCount = new AtomicLong(0L);
/*     */   
/*     */ 
/*  13 */   protected final AtomicLong missCount = new AtomicLong(0L);
/*     */   
/*     */ 
/*  16 */   protected final AtomicLong accessCount = new AtomicLong(0L);
/*     */   
/*     */ 
/*  19 */   protected final AtomicLong evictionCount = new AtomicLong(0L);
/*     */   
/*     */ 
/*  22 */   protected final AtomicLong eagerEvictionRunCount = new AtomicLong(0L);
/*     */   
/*     */ 
/*  25 */   protected final AtomicLong eagerEvictionCount = new AtomicLong(0L);
/*     */   
/*     */ 
/*  28 */   protected final AtomicLong removedCount = new AtomicLong(0L);
/*     */   
/*     */   public void miss() {
/*  31 */     this.missCount.incrementAndGet();
/*     */   }
/*     */   
/*     */   public void hit() {
/*  35 */     this.hitCount.incrementAndGet();
/*     */   }
/*     */   
/*     */   public void access() {
/*  39 */     this.accessCount.incrementAndGet();
/*     */   }
/*     */   
/*     */   public void evict()
/*     */   {
/*  44 */     this.evictionCount.incrementAndGet();
/*     */   }
/*     */   
/*     */   public void removed()
/*     */   {
/*  49 */     this.removedCount.incrementAndGet();
/*     */   }
/*     */   
/*     */   public void eagerEvictionRun()
/*     */   {
/*  54 */     this.eagerEvictionRunCount.incrementAndGet();
/*     */   }
/*     */   
/*     */   public void eagerEvict()
/*     */   {
/*  59 */     this.eagerEvictionCount.incrementAndGet();
/*     */   }
/*     */   
/*     */   public long getHitCount() {
/*  63 */     return this.hitCount.get();
/*     */   }
/*     */   
/*     */   public long getMissCount() {
/*  67 */     return this.missCount.get();
/*     */   }
/*     */   
/*     */   public long getAccessCount() {
/*  71 */     return getRequestCount() + getRemovedCount() + this.accessCount.get();
/*     */   }
/*     */   
/*     */ 
/*     */   public long getEvictionCount()
/*     */   {
/*  77 */     return this.evictionCount.get();
/*     */   }
/*     */   
/*     */   public long getRemovedCount()
/*     */   {
/*  82 */     return this.removedCount.get();
/*     */   }
/*     */   
/*     */   public long getEagerEvictionRunCount()
/*     */   {
/*  87 */     return this.eagerEvictionRunCount.get();
/*     */   }
/*     */   
/*     */   public long getEagerlyEvictedCount()
/*     */   {
/*  92 */     return this.eagerEvictionCount.get();
/*     */   }
/*     */   
/*     */   public long getRequestCount() {
/*  96 */     return getHitCount() + getMissCount();
/*     */   }
/*     */   
/*     */   public String getHitRatio()
/*     */   {
/* 101 */     double hitRatio = (float)getHitCount() / (float)getRequestCount();
/* 102 */     if (getHitCount() == 0L) return "0";
/* 103 */     return CacheUtils.formatPercent(hitRatio, 2);
/*     */   }
/*     */   
/*     */ 
/*     */   public long getTotalEvictionCount()
/*     */   {
/* 109 */     return getEvictionCount() + getEagerlyEvictedCount() + getRemovedCount();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public String toString()
/*     */   {
/* 116 */     return "AsupLRUCacheStats [hitCount=" + this.hitCount.get() + ", missCount=" + this.missCount.get() + ", accessCount=" + getAccessCount() + ", evictionCount=" + this.evictionCount.get() + ", eagerEvictionRunCount=" + this.eagerEvictionRunCount.get() + ", eagerEvictionCount=" + this.eagerEvictionCount.get() + ", removedCount=" + this.removedCount.get() + ", totalEvictionCount=" + getTotalEvictionCount() + "]";
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\cache\LRU\AsupLRUCacheStats.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */