/*    */ package com.netapp.asup.client.helper;
/*    */ 
/*    */ import com.netapp.asup.client.arma.ARMAObject;
/*    */ import com.netapp.asup.client.arma.data.ARMAObjectInstance;
/*    */ import com.netapp.asup.client.arma.data.ARMAObjectInstanceIterator;
/*    */ import com.netapp.asup.exception.ARMAException;
/*    */ import java.io.ByteArrayOutputStream;
/*    */ import java.io.UnsupportedEncodingException;
/*    */ import javax.xml.stream.FactoryConfigurationError;
/*    */ import javax.xml.stream.XMLOutputFactory;
/*    */ import javax.xml.stream.XMLStreamException;
/*    */ import javax.xml.stream.XMLStreamWriter;
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ObjectDataXmlHelper
/*    */ {
/*    */   private static final String ENCODING_TYPE = "UTF-8";
/*    */   private static final String INSTANCE = "instance";
/*    */   private static final String OBJECT = "object";
/*    */   private static final String NAME = "name";
/*    */   
/*    */   public static XMLStreamWriter initializeXmlWriter(ByteArrayOutputStream outStream)
/*    */     throws FactoryConfigurationError, XMLStreamException
/*    */   {
/* 26 */     XMLOutputFactory factory = XMLOutputFactory.newInstance();
/* 27 */     XMLStreamWriter writer = factory.createXMLStreamWriter(outStream, "UTF-8");
/*    */     
/*    */ 
/* 30 */     return writer;
/*    */   }
/*    */   
/*    */   public static void closeXmlWriter(XMLStreamWriter writer)
/*    */     throws XMLStreamException
/*    */   {
/* 36 */     writer.flush();
/* 37 */     writer.close();
/*    */   }
/*    */   
/*    */ 
/*    */   public static void writeObjectData(XMLStreamWriter writer, String objectName, ARMAObjectInstanceIterator instances)
/*    */     throws XMLStreamException
/*    */   {
/* 44 */     if (instances.size() > 0) {
/* 45 */       writer.writeStartElement("object");
/* 46 */       writer.writeAttribute("name", objectName);
/*    */       
/* 48 */       while (instances.hasNext()) {
/* 49 */         writeInstanceData(writer, objectName, instances.next());
/*    */       }
/*    */       
/* 52 */       writer.writeEndElement();
/*    */     }
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public static void writeInstanceData(XMLStreamWriter writer, String objectName, ARMAObjectInstance instance)
/*    */     throws XMLStreamException
/*    */   {
/* 61 */     writer.writeStartElement("instance");
/* 62 */     writer.writeStartElement(objectName);
/* 63 */     XMLHelper.writeConfigAndStatusAttrs(writer, instance.getAttributes());
/* 64 */     writer.writeEndElement();
/* 65 */     writer.writeEndElement();
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public static String serializeObject(ARMAObject object)
/*    */     throws FactoryConfigurationError, ARMAException, XMLStreamException, UnsupportedEncodingException
/*    */   {
/* 73 */     ByteArrayOutputStream outStream = new ByteArrayOutputStream();
/* 74 */     XMLStreamWriter objwriter = initializeXmlWriter(outStream);
/*    */     
/* 76 */     ARMAObjectInstanceIterator it = object.getInstances();
/* 77 */     writeObjectData(objwriter, object.getObjectName(), it);
/*    */     
/* 79 */     closeXmlWriter(objwriter);
/*    */     
/* 81 */     return outStream.toString("UTF-8");
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public static String serializeInstance(ARMAObjectInstance instance)
/*    */     throws FactoryConfigurationError, XMLStreamException, UnsupportedEncodingException
/*    */   {
/* 89 */     ByteArrayOutputStream outStream = new ByteArrayOutputStream();
/* 90 */     XMLStreamWriter writer = initializeXmlWriter(outStream);
/* 91 */     writeInstanceData(writer, instance.getObjectName(), instance);
/*    */     
/* 93 */     closeXmlWriter(writer);
/* 94 */     return outStream.toString("UTF-8");
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\client\helper\ObjectDataXmlHelper.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */