/*     */ package com.sun.xml.bind.v2.model.impl;
/*     */ 
/*     */ import com.sun.xml.bind.WhiteSpaceProcessor;
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.model.annotation.Locatable;
/*     */ import com.sun.xml.bind.v2.model.annotation.RuntimeAnnotationReader;
/*     */ import com.sun.xml.bind.v2.model.core.ID;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import com.sun.xml.bind.v2.model.nav.ReflectionNavigator;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeNonElement;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeNonElementRef;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimePropertyInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeTypeInfoSet;
/*     */ import com.sun.xml.bind.v2.runtime.FilterTransducer;
/*     */ import com.sun.xml.bind.v2.runtime.IllegalAnnotationException;
/*     */ import com.sun.xml.bind.v2.runtime.InlineBinaryTransducer;
/*     */ import com.sun.xml.bind.v2.runtime.MimeTypedTransducer;
/*     */ import com.sun.xml.bind.v2.runtime.SchemaTypeTransducer;
/*     */ import com.sun.xml.bind.v2.runtime.Transducer;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext;
/*     */ import java.lang.reflect.Field;
/*     */ import java.lang.reflect.Method;
/*     */ import java.lang.reflect.Type;
/*     */ import javax.activation.MimeType;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class RuntimeModelBuilder
/*     */   extends ModelBuilder<Type, Class, Field, Method>
/*     */ {
/*     */   public RuntimeModelBuilder(RuntimeAnnotationReader annotationReader, String defaultNamespaceRemap)
/*     */   {
/*  43 */     super(annotationReader, Navigator.REFLECTION, defaultNamespaceRemap);
/*     */   }
/*     */   
/*     */   public RuntimeNonElement getClassInfo(Class clazz, Locatable upstream)
/*     */   {
/*  48 */     return (RuntimeNonElement)super.getClassInfo(clazz, upstream);
/*     */   }
/*     */   
/*     */   protected RuntimeEnumLeafInfoImpl createEnumLeafInfo(Class clazz, Locatable upstream)
/*     */   {
/*  53 */     return new RuntimeEnumLeafInfoImpl(this, upstream, clazz);
/*     */   }
/*     */   
/*     */   protected RuntimeClassInfoImpl createClassInfo(Class clazz, Locatable upstream)
/*     */   {
/*  58 */     return new RuntimeClassInfoImpl(this, upstream, clazz);
/*     */   }
/*     */   
/*     */   public RuntimeElementInfoImpl createElementInfo(RegistryInfoImpl<Type, Class, Field, Method> registryInfo, Method method) throws IllegalAnnotationException
/*     */   {
/*  63 */     return new RuntimeElementInfoImpl(this, registryInfo, method);
/*     */   }
/*     */   
/*     */   public RuntimeArrayInfoImpl createArrayInfo(Locatable upstream, Type arrayType)
/*     */   {
/*  68 */     return new RuntimeArrayInfoImpl(this, upstream, (Class)arrayType);
/*     */   }
/*     */   
/*     */   public ReflectionNavigator getNavigator() {
/*  72 */     return (ReflectionNavigator)this.nav;
/*     */   }
/*     */   
/*     */   protected RuntimeTypeInfoSetImpl createTypeInfoSet()
/*     */   {
/*  77 */     return new RuntimeTypeInfoSetImpl(this.reader);
/*     */   }
/*     */   
/*     */   public RuntimeTypeInfoSet link()
/*     */   {
/*  82 */     return (RuntimeTypeInfoSet)super.link();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static Transducer createTransducer(RuntimeNonElementRef ref)
/*     */   {
/*  94 */     Transducer t = ref.getTarget().getTransducer();
/*  95 */     RuntimePropertyInfo src = ref.getSource();
/*  96 */     ID id = src.id();
/*     */     
/*  98 */     if (id == ID.IDREF) {
/*  99 */       return RuntimeBuiltinLeafInfoImpl.STRING;
/*     */     }
/* 101 */     if (id == ID.ID) {
/* 102 */       t = new IDTransducerImpl(t);
/*     */     }
/* 104 */     MimeType emt = src.getExpectedMimeType();
/* 105 */     if (emt != null) {
/* 106 */       t = new MimeTypedTransducer(t, emt);
/*     */     }
/* 108 */     if (src.inlineBinaryData()) {
/* 109 */       t = new InlineBinaryTransducer(t);
/*     */     }
/* 111 */     if (src.getSchemaType() != null) {
/* 112 */       t = new SchemaTypeTransducer(t, src.getSchemaType());
/*     */     }
/* 114 */     return t;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static final class IDTransducerImpl<ValueT>
/*     */     extends FilterTransducer<ValueT>
/*     */   {
/*     */     public IDTransducerImpl(Transducer<ValueT> core)
/*     */     {
/* 127 */       super();
/*     */     }
/*     */     
/*     */     public ValueT parse(CharSequence lexical) throws AccessorException, SAXException
/*     */     {
/* 132 */       String value = WhiteSpaceProcessor.trim(lexical).toString();
/* 133 */       UnmarshallingContext.getInstance().addToIdTable(value);
/* 134 */       return (ValueT)this.core.parse(value);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\RuntimeModelBuilder.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */