/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.xml.bind.DatatypeConverterImpl;
/*     */ import com.sun.xml.bind.marshaller.CharacterEscapeHandler;
/*     */ import com.sun.xml.bind.marshaller.DataWriter;
/*     */ import com.sun.xml.bind.marshaller.DumbEscapeHandler;
/*     */ import com.sun.xml.bind.marshaller.MinimumEscapeHandler;
/*     */ import com.sun.xml.bind.marshaller.NamespacePrefixMapper;
/*     */ import com.sun.xml.bind.marshaller.NioEscapeHandler;
/*     */ import com.sun.xml.bind.marshaller.SAX2DOMEx;
/*     */ import com.sun.xml.bind.marshaller.XMLWriter;
/*     */ import com.sun.xml.bind.v2.runtime.output.C14nXmlOutput;
/*     */ import com.sun.xml.bind.v2.runtime.output.Encoded;
/*     */ import com.sun.xml.bind.v2.runtime.output.ForkXmlOutput;
/*     */ import com.sun.xml.bind.v2.runtime.output.IndentingUTF8XmlOutput;
/*     */ import com.sun.xml.bind.v2.runtime.output.NamespaceContextImpl;
/*     */ import com.sun.xml.bind.v2.runtime.output.SAXOutput;
/*     */ import com.sun.xml.bind.v2.runtime.output.UTF8XmlOutput;
/*     */ import com.sun.xml.bind.v2.runtime.output.XMLEventWriterOutput;
/*     */ import com.sun.xml.bind.v2.runtime.output.XMLStreamWriterOutput;
/*     */ import com.sun.xml.bind.v2.runtime.output.XmlOutput;
/*     */ import com.sun.xml.bind.v2.util.FatalAdapter;
/*     */ import java.io.BufferedWriter;
/*     */ import java.io.Closeable;
/*     */ import java.io.FileOutputStream;
/*     */ import java.io.Flushable;
/*     */ import java.io.IOException;
/*     */ import java.io.OutputStream;
/*     */ import java.io.OutputStreamWriter;
/*     */ import java.io.UnsupportedEncodingException;
/*     */ import java.io.Writer;
/*     */ import javax.xml.bind.DatatypeConverter;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.bind.MarshalException;
/*     */ import javax.xml.bind.Marshaller.Listener;
/*     */ import javax.xml.bind.PropertyException;
/*     */ import javax.xml.bind.ValidationEvent;
/*     */ import javax.xml.bind.ValidationEventHandler;
/*     */ import javax.xml.bind.annotation.adapters.XmlAdapter;
/*     */ import javax.xml.bind.attachment.AttachmentMarshaller;
/*     */ import javax.xml.bind.helpers.AbstractMarshallerImpl;
/*     */ import javax.xml.stream.XMLEventWriter;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.XMLStreamWriter;
/*     */ import javax.xml.transform.Result;
/*     */ import javax.xml.transform.dom.DOMResult;
/*     */ import javax.xml.transform.sax.SAXResult;
/*     */ import javax.xml.transform.stream.StreamResult;
/*     */ import javax.xml.validation.Schema;
/*     */ import javax.xml.validation.ValidatorHandler;
/*     */ import org.w3c.dom.Document;
/*     */ import org.w3c.dom.Node;
/*     */ import org.xml.sax.ContentHandler;
/*     */ import org.xml.sax.SAXException;
/*     */ import org.xml.sax.helpers.XMLFilterImpl;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class MarshallerImpl
/*     */   extends AbstractMarshallerImpl
/*     */   implements ValidationEventHandler
/*     */ {
/*  92 */   private String indent = "    ";
/*     */   
/*     */ 
/*  95 */   private NamespacePrefixMapper prefixMapper = null;
/*     */   
/*     */ 
/*  98 */   private CharacterEscapeHandler escapeHandler = null;
/*     */   
/*     */ 
/* 101 */   private String header = null;
/*     */   
/*     */ 
/*     */ 
/*     */   final JAXBContextImpl context;
/*     */   
/*     */ 
/*     */   protected final XMLSerializer serializer;
/*     */   
/*     */ 
/*     */   private Schema schema;
/*     */   
/*     */ 
/* 114 */   private Marshaller.Listener externalListener = null;
/*     */   
/*     */   private boolean c14nSupport;
/*     */   
/*     */   private Flushable toBeFlushed;
/*     */   
/*     */   private Closeable toBeClosed;
/*     */   protected static final String INDENT_STRING = "com.sun.xml.bind.indentString";
/*     */   protected static final String PREFIX_MAPPER = "com.sun.xml.bind.namespacePrefixMapper";
/*     */   protected static final String ENCODING_HANDLER = "com.sun.xml.bind.characterEscapeHandler";
/*     */   protected static final String XMLDECLARATION = "com.sun.xml.bind.xmlDeclaration";
/*     */   protected static final String XML_HEADERS = "com.sun.xml.bind.xmlHeaders";
/*     */   protected static final String C14N = "com.sun.xml.bind.c14n";
/*     */   
/*     */   public MarshallerImpl(JAXBContextImpl c, AssociationMap assoc)
/*     */   {
/* 130 */     DatatypeConverter.setDatatypeConverter(DatatypeConverterImpl.theInstance);
/*     */     
/* 132 */     this.context = c;
/* 133 */     this.serializer = new XMLSerializer(this);
/* 134 */     this.c14nSupport = this.context.c14nSupport;
/*     */     try
/*     */     {
/* 137 */       setEventHandler(this);
/*     */     } catch (JAXBException e) {
/* 139 */       throw new AssertionError(e);
/*     */     }
/*     */   }
/*     */   
/*     */   public JAXBContextImpl getContext() {
/* 144 */     return this.context;
/*     */   }
/*     */   
/*     */   public void marshal(Object obj, XMLStreamWriter writer) throws JAXBException {
/* 148 */     write(obj, XMLStreamWriterOutput.create(writer), new StAXPostInitAction(writer, this.serializer));
/*     */   }
/*     */   
/*     */   public void marshal(Object obj, XMLEventWriter writer) throws JAXBException {
/* 152 */     write(obj, new XMLEventWriterOutput(writer), new StAXPostInitAction(writer, this.serializer));
/*     */   }
/*     */   
/*     */   public void marshal(Object obj, XmlOutput output) throws JAXBException {
/* 156 */     write(obj, output, null);
/*     */   }
/*     */   
/*     */ 
/*     */   final XmlOutput createXmlOutput(Result result)
/*     */     throws JAXBException
/*     */   {
/* 163 */     if ((result instanceof SAXResult)) {
/* 164 */       return new SAXOutput(((SAXResult)result).getHandler());
/*     */     }
/* 166 */     if ((result instanceof DOMResult)) {
/* 167 */       Node node = ((DOMResult)result).getNode();
/*     */       
/* 169 */       if (node == null) {
/* 170 */         Document doc = JAXBContextImpl.createDom();
/* 171 */         ((DOMResult)result).setNode(doc);
/* 172 */         return new SAXOutput(new SAX2DOMEx(doc));
/*     */       }
/* 174 */       return new SAXOutput(new SAX2DOMEx(node));
/*     */     }
/*     */     
/* 177 */     if ((result instanceof StreamResult)) {
/* 178 */       StreamResult sr = (StreamResult)result;
/*     */       
/* 180 */       if (sr.getWriter() != null)
/* 181 */         return createWriter(sr.getWriter());
/* 182 */       if (sr.getOutputStream() != null)
/* 183 */         return createWriter(sr.getOutputStream());
/* 184 */       if (sr.getSystemId() != null) {
/* 185 */         String fileURL = sr.getSystemId();
/*     */         
/* 187 */         if (fileURL.startsWith("file:///")) {
/* 188 */           if (fileURL.substring(8).indexOf(":") > 0) {
/* 189 */             fileURL = fileURL.substring(8);
/*     */           } else {
/* 191 */             fileURL = fileURL.substring(7);
/*     */           }
/*     */         }
/*     */         try {
/* 195 */           FileOutputStream fos = new FileOutputStream(fileURL);
/* 196 */           assert (this.toBeClosed == null);
/* 197 */           this.toBeClosed = fos;
/* 198 */           return createWriter(fos);
/*     */         } catch (IOException e) {
/* 200 */           throw new MarshalException(e);
/*     */         }
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 206 */     throw new MarshalException(Messages.UNSUPPORTED_RESULT.format(new Object[0]));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   final Runnable createPostInitAction(Result result)
/*     */   {
/* 213 */     if ((result instanceof DOMResult)) {
/* 214 */       Node node = ((DOMResult)result).getNode();
/* 215 */       return new DomPostInitAction(node, this.serializer);
/*     */     }
/* 217 */     return null;
/*     */   }
/*     */   
/*     */   public void marshal(Object target, Result result) throws JAXBException {
/* 221 */     write(target, createXmlOutput(result), createPostInitAction(result));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final <T> void write(Name rootTagName, JaxBeanInfo<T> bi, T obj, XmlOutput out, Runnable postInitAction)
/*     */     throws JAXBException
/*     */   {
/*     */     try
/*     */     {
/*     */       return;
/*     */     }
/*     */     catch (IOException e) {}finally
/*     */     {
/* 255 */       cleanUp();
/*     */     }
/*     */   }
/*     */   
/*     */   private void write(Object obj, XmlOutput out, Runnable postInitAction)
/*     */     throws JAXBException
/*     */   {
/*     */     try
/*     */     {
/* 264 */       if (obj == null) {
/* 265 */         throw new IllegalArgumentException(Messages.NOT_MARSHALLABLE.format(new Object[0]));
/*     */       }
/* 267 */       if (this.schema != null)
/*     */       {
/* 269 */         ValidatorHandler validator = this.schema.newValidatorHandler();
/* 270 */         validator.setErrorHandler(new FatalAdapter(this.serializer));
/*     */         
/* 272 */         XMLFilterImpl f = new XMLFilterImpl() {
/*     */           public void startPrefixMapping(String prefix, String uri) throws SAXException {
/* 274 */             super.startPrefixMapping(prefix.intern(), uri.intern());
/*     */           }
/* 276 */         };
/* 277 */         f.setContentHandler(validator);
/* 278 */         out = new ForkXmlOutput(new SAXOutput(f)
/*     */         {
/*     */           public void startDocument(XMLSerializer serializer, boolean fragment, int[] nsUriIndex2prefixIndex, NamespaceContextImpl nsContext) throws SAXException, IOException, XMLStreamException {
/* 281 */             super.startDocument(serializer, false, nsUriIndex2prefixIndex, nsContext);
/*     */           }
/*     */           
/*     */ 
/* 285 */           public void endDocument(boolean fragment) throws SAXException, IOException, XMLStreamException { super.endDocument(false); } }, out);
/*     */       }
/*     */       
/*     */ 
/*     */       try
/*     */       {
/* 291 */         prewrite(out, isFragment(), postInitAction);
/* 292 */         this.serializer.childAsRoot(obj);
/* 293 */         postwrite(out);
/*     */       } catch (SAXException e) {
/* 295 */         throw new MarshalException(e);
/*     */       } catch (IOException e) {
/* 297 */         throw new MarshalException(e);
/*     */       } catch (XMLStreamException e) {
/* 299 */         throw new MarshalException(e);
/*     */       } finally {
/* 301 */         this.serializer.close();
/*     */       }
/*     */     } finally {
/* 304 */       cleanUp();
/*     */     }
/*     */   }
/*     */   
/*     */   private void cleanUp() {
/* 309 */     if (this.toBeFlushed != null) {
/*     */       try {
/* 311 */         this.toBeFlushed.flush();
/*     */       }
/*     */       catch (IOException e) {}
/*     */     }
/* 315 */     if (this.toBeClosed != null) {
/*     */       try {
/* 317 */         this.toBeClosed.close();
/*     */       }
/*     */       catch (IOException e) {}
/*     */     }
/* 321 */     this.toBeFlushed = null;
/* 322 */     this.toBeClosed = null;
/*     */   }
/*     */   
/*     */   private void prewrite(XmlOutput out, boolean fragment, Runnable postInitAction)
/*     */     throws IOException, SAXException, XMLStreamException
/*     */   {
/* 328 */     this.serializer.startDocument(out, fragment, getSchemaLocation(), getNoNSSchemaLocation());
/* 329 */     if (postInitAction != null) postInitAction.run();
/* 330 */     if (this.prefixMapper != null)
/*     */     {
/* 332 */       String[] decls = this.prefixMapper.getContextualNamespaceDecls();
/* 333 */       if (decls != null) {
/* 334 */         for (int i = 0; i < decls.length; i += 2) {
/* 335 */           String prefix = decls[i];
/* 336 */           String nsUri = decls[(i + 1)];
/* 337 */           if ((nsUri != null) && (prefix != null))
/* 338 */             this.serializer.addInscopeBinding(nsUri, prefix);
/*     */         }
/*     */       }
/*     */     }
/* 342 */     this.serializer.setPrefixMapper(this.prefixMapper);
/*     */   }
/*     */   
/*     */   private void postwrite(XmlOutput out) throws IOException, SAXException, XMLStreamException {
/* 346 */     this.serializer.endDocument();
/* 347 */     this.serializer.reconcileID();
/* 348 */     out.flush();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected CharacterEscapeHandler createEscapeHandler(String encoding)
/*     */   {
/* 359 */     if (this.escapeHandler != null)
/*     */     {
/* 361 */       return this.escapeHandler;
/*     */     }
/* 363 */     if (encoding.startsWith("UTF"))
/*     */     {
/*     */ 
/* 366 */       return MinimumEscapeHandler.theInstance;
/*     */     }
/*     */     
/*     */     try
/*     */     {
/* 371 */       return new NioEscapeHandler(getJavaEncoding(encoding));
/*     */     }
/*     */     catch (Throwable e) {}
/* 374 */     return DumbEscapeHandler.theInstance;
/*     */   }
/*     */   
/*     */ 
/*     */   public XmlOutput createWriter(Writer w, String encoding)
/*     */   {
/* 380 */     if (!(w instanceof BufferedWriter)) {
/* 381 */       w = new BufferedWriter(w);
/*     */     }
/* 383 */     assert (this.toBeFlushed == null);
/* 384 */     this.toBeFlushed = w;
/*     */     
/* 386 */     CharacterEscapeHandler ceh = createEscapeHandler(encoding);
/*     */     XMLWriter xw;
/*     */     XMLWriter xw;
/* 389 */     if (isFormattedOutput()) {
/* 390 */       DataWriter d = new DataWriter(w, encoding, ceh);
/* 391 */       d.setIndentStep(this.indent);
/* 392 */       xw = d;
/*     */     } else {
/* 394 */       xw = new XMLWriter(w, encoding, ceh);
/*     */     }
/* 396 */     xw.setXmlDecl(!isFragment());
/* 397 */     xw.setHeader(this.header);
/* 398 */     return new SAXOutput(xw);
/*     */   }
/*     */   
/*     */   public XmlOutput createWriter(Writer w) {
/* 402 */     return createWriter(w, getEncoding());
/*     */   }
/*     */   
/*     */   public XmlOutput createWriter(OutputStream os) throws JAXBException {
/* 406 */     return createWriter(os, getEncoding());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public XmlOutput createWriter(OutputStream os, String encoding)
/*     */     throws JAXBException
/*     */   {
/* 414 */     if (encoding.equals("UTF-8")) {
/* 415 */       Encoded[] table = this.context.getUTF8NameTable();
/* 416 */       if (isFormattedOutput()) {
/* 417 */         return new IndentingUTF8XmlOutput(os, this.indent, table);
/*     */       }
/* 419 */       if (this.c14nSupport) {
/* 420 */         return new C14nXmlOutput(os, table, this.context.c14nSupport);
/*     */       }
/* 422 */       return new UTF8XmlOutput(os, table);
/*     */     }
/*     */     
/*     */     try
/*     */     {
/* 427 */       return createWriter(new OutputStreamWriter(os, getJavaEncoding(encoding)), encoding);
/*     */     }
/*     */     catch (UnsupportedEncodingException e)
/*     */     {
/* 431 */       throw new MarshalException(Messages.UNSUPPORTED_ENCODING.format(new Object[] { encoding }), e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public Object getProperty(String name)
/*     */     throws PropertyException
/*     */   {
/* 439 */     if ("com.sun.xml.bind.indentString".equals(name))
/* 440 */       return this.indent;
/* 441 */     if ("com.sun.xml.bind.characterEscapeHandler".equals(name))
/* 442 */       return this.escapeHandler;
/* 443 */     if ("com.sun.xml.bind.namespacePrefixMapper".equals(name))
/* 444 */       return this.prefixMapper;
/* 445 */     if ("com.sun.xml.bind.xmlDeclaration".equals(name))
/* 446 */       return Boolean.valueOf(!isFragment());
/* 447 */     if ("com.sun.xml.bind.xmlHeaders".equals(name))
/* 448 */       return this.header;
/* 449 */     if ("com.sun.xml.bind.c14n".equals(name)) {
/* 450 */       return Boolean.valueOf(this.c14nSupport);
/*     */     }
/* 452 */     return super.getProperty(name);
/*     */   }
/*     */   
/*     */   public void setProperty(String name, Object value) throws PropertyException {
/* 456 */     if ("com.sun.xml.bind.indentString".equals(name)) {
/* 457 */       checkString(name, value);
/* 458 */       this.indent = ((String)value);
/* 459 */       return;
/*     */     }
/* 461 */     if ("com.sun.xml.bind.characterEscapeHandler".equals(name)) {
/* 462 */       if (!(value instanceof CharacterEscapeHandler)) {
/* 463 */         throw new PropertyException(Messages.MUST_BE_X.format(new Object[] { name, CharacterEscapeHandler.class.getName(), value.getClass().getName() }));
/*     */       }
/*     */       
/*     */ 
/*     */ 
/* 468 */       this.escapeHandler = ((CharacterEscapeHandler)value);
/* 469 */       return;
/*     */     }
/* 471 */     if ("com.sun.xml.bind.namespacePrefixMapper".equals(name)) {
/* 472 */       if (!(value instanceof NamespacePrefixMapper)) {
/* 473 */         throw new PropertyException(Messages.MUST_BE_X.format(new Object[] { name, NamespacePrefixMapper.class.getName(), value.getClass().getName() }));
/*     */       }
/*     */       
/*     */ 
/*     */ 
/* 478 */       this.prefixMapper = ((NamespacePrefixMapper)value);
/* 479 */       return;
/*     */     }
/* 481 */     if ("com.sun.xml.bind.xmlDeclaration".equals(name)) {
/* 482 */       checkBoolean(name, value);
/*     */       
/*     */ 
/* 485 */       super.setProperty("jaxb.fragment", Boolean.valueOf(!((Boolean)value).booleanValue()));
/* 486 */       return;
/*     */     }
/* 488 */     if ("com.sun.xml.bind.xmlHeaders".equals(name)) {
/* 489 */       checkString(name, value);
/* 490 */       this.header = ((String)value);
/* 491 */       return;
/*     */     }
/* 493 */     if ("com.sun.xml.bind.c14n".equals(name)) {
/* 494 */       checkBoolean(name, value);
/* 495 */       this.c14nSupport = ((Boolean)value).booleanValue();
/* 496 */       return;
/*     */     }
/*     */     
/* 499 */     super.setProperty(name, value);
/*     */   }
/*     */   
/*     */ 
/*     */   private void checkBoolean(String name, Object value)
/*     */     throws PropertyException
/*     */   {
/* 506 */     if (!(value instanceof Boolean)) {
/* 507 */       throw new PropertyException(Messages.MUST_BE_X.format(new Object[] { name, Boolean.class.getName(), value.getClass().getName() }));
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void checkString(String name, Object value)
/*     */     throws PropertyException
/*     */   {
/* 518 */     if (!(value instanceof String)) {
/* 519 */       throw new PropertyException(Messages.MUST_BE_X.format(new Object[] { name, String.class.getName(), value.getClass().getName() }));
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public <A extends XmlAdapter> void setAdapter(Class<A> type, A adapter)
/*     */   {
/* 528 */     if (type == null)
/* 529 */       throw new IllegalArgumentException();
/* 530 */     this.serializer.putAdapter(type, adapter);
/*     */   }
/*     */   
/*     */   public <A extends XmlAdapter> A getAdapter(Class<A> type)
/*     */   {
/* 535 */     if (type == null)
/* 536 */       throw new IllegalArgumentException();
/* 537 */     if (this.serializer.containsAdapter(type))
/*     */     {
/* 539 */       return this.serializer.getAdapter(type);
/*     */     }
/* 541 */     return null;
/*     */   }
/*     */   
/*     */   public void setAttachmentMarshaller(AttachmentMarshaller am)
/*     */   {
/* 546 */     this.serializer.attachmentMarshaller = am;
/*     */   }
/*     */   
/*     */   public AttachmentMarshaller getAttachmentMarshaller()
/*     */   {
/* 551 */     return this.serializer.attachmentMarshaller;
/*     */   }
/*     */   
/*     */   public Schema getSchema() {
/* 555 */     return this.schema;
/*     */   }
/*     */   
/*     */   public void setSchema(Schema s) {
/* 559 */     this.schema = s;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean handleEvent(ValidationEvent event)
/*     */   {
/* 567 */     return false;
/*     */   }
/*     */   
/*     */   public Marshaller.Listener getListener() {
/* 571 */     return this.externalListener;
/*     */   }
/*     */   
/*     */   public void setListener(Marshaller.Listener listener) {
/* 575 */     this.externalListener = listener;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\MarshallerImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */