/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.resources;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.ValidationException;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.dto.common.ErrorDescriptor;
/*    */ import java.util.Arrays;
/*    */ import java.util.List;
/*    */ import javax.ws.rs.core.Response;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ResourceValidationErrorHandler
/*    */   extends DefaultErrorHandler
/*    */ {
/*    */   protected void handleBodyError(Response response)
/*    */   {
/* 36 */     List<ErrorDescriptor> errorDescriptors = null;
/* 37 */     if ((response.getHeaderString("Content-Type").contains("xml")) || (response.getHeaderString("Content-Type").contains("json")))
/*    */     {
/* 39 */       ErrorDescriptor[] validationErrors = (ErrorDescriptor[])readBody(response, ErrorDescriptor[].class);
/*    */       
/* 41 */       if (validationErrors == null) {
/* 42 */         super.handleBodyError(response);
/* 43 */         return;
/*    */       }
/*    */       
/* 46 */       errorDescriptors = Arrays.asList(validationErrors);
/* 47 */       throw new ValidationException(generateErrorMessage(errorDescriptors), errorDescriptors);
/*    */     }
/* 49 */     super.handleBodyError(response);
/*    */   }
/*    */   
/*    */   private String generateErrorMessage(List<ErrorDescriptor> errorDescriptors)
/*    */   {
/* 54 */     StringBuilder sb = new StringBuilder();
/* 55 */     if (errorDescriptors != null) {
/* 56 */       for (ErrorDescriptor errorDescriptor : errorDescriptors) {
/* 57 */         String message = errorDescriptor.getMessage();
/* 58 */         sb.append("\n\t\t").append(message != null ? message : errorDescriptor.getErrorCode());
/*    */       }
/*    */     }
/* 61 */     return sb.toString();
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\resources\ResourceValidationErrorHandler.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */