/*    */ package com.netapp.asup.data.utils;
/*    */ 
/*    */ import com.netapp.asup.common.AsupLogger;
/*    */ import com.netapp.asup.exception.ARMAException;
/*    */ import java.security.MessageDigest;
/*    */ import java.security.NoSuchAlgorithmException;
/*    */ import org.apache.avro.Schema;
/*    */ 
/*    */ 
/*    */ 
/*    */ public class Md5Util
/*    */ {
/* 13 */   private static final AsupLogger logger = AsupLogger.getLogger(Md5Util.class);
/*    */   private static final String MD5_CALCULATION = "MD5_CALCULATION";
/*    */   private static final String MD5 = "MD5";
/*    */   
/*    */   public static String getMd5Value(Schema latestSchema) throws ARMAException {
/* 18 */     StringBuffer hexString = new StringBuffer();
/*    */     try {
/* 20 */       MessageDigest md = MessageDigest.getInstance("MD5");
/* 21 */       md.update(latestSchema.toString().getBytes());
/* 22 */       byte[] byteData = md.digest();
/*    */       
/* 24 */       for (int i = 0; i < byteData.length; i++) {
/* 25 */         String hex = Integer.toHexString(0xFF & byteData[i]);
/* 26 */         if (hex.length() == 1) hexString.append('0');
/* 27 */         hexString.append(hex);
/*    */       }
/*    */     } catch (NoSuchAlgorithmException e) {
/* 30 */       logger.warn("Error calculatingf md5 ", e.getLocalizedMessage());
/* 31 */       throw new ARMAException(logger, "MD5_CALCULATION", "Error calculating Md5 for avro Schema.", e);
/*    */     }
/* 33 */     return hexString.toString();
/*    */   }
/*    */   
/*    */   public static String getMd5Value(String value) throws Exception {
/* 37 */     StringBuffer hexString = new StringBuffer();
/*    */     try {
/* 39 */       MessageDigest md = MessageDigest.getInstance("MD5");
/* 40 */       md.update(value.getBytes());
/* 41 */       byte[] byteData = md.digest();
/*    */       
/* 43 */       for (int i = 0; i < byteData.length; i++) {
/* 44 */         String hex = Integer.toHexString(0xFF & byteData[i]);
/* 45 */         if (hex.length() == 1) hexString.append('0');
/* 46 */         hexString.append(hex);
/*    */       }
/*    */     } catch (NoSuchAlgorithmException e) {
/* 49 */       logger.warn("Error calculatingf md5 ", e.getLocalizedMessage());
/* 50 */       throw new Exception("Error calculating Md5 for avro Schema.", e);
/*    */     }
/* 52 */     return hexString.toString();
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\utils\Md5Util.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */