/*    */ package com.sun.xml.bind.api;
/*    */ 
/*    */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*    */ import com.sun.xml.bind.v2.model.nav.ReflectionNavigator;
/*    */ import java.lang.annotation.Annotation;
/*    */ import java.lang.reflect.Type;
/*    */ import java.util.Collection;
/*    */ import javax.xml.namespace.QName;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class TypeReference
/*    */ {
/*    */   public final QName tagName;
/*    */   public final Type type;
/*    */   public final Annotation[] annotations;
/*    */   
/*    */   public TypeReference(QName tagName, Type type, Annotation... annotations)
/*    */   {
/* 44 */     if ((tagName == null) || (type == null) || (annotations == null)) {
/* 45 */       throw new IllegalArgumentException();
/*    */     }
/* 47 */     this.tagName = new QName(tagName.getNamespaceURI().intern(), tagName.getLocalPart().intern(), tagName.getPrefix());
/* 48 */     this.type = type;
/* 49 */     this.annotations = annotations;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   public <A extends Annotation> A get(Class<A> annotationType)
/*    */   {
/* 57 */     for (Annotation a : this.annotations) {
/* 58 */       if (a.annotationType() == annotationType)
/* 59 */         return (Annotation)annotationType.cast(a);
/*    */     }
/* 61 */     return null;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public TypeReference toItemType()
/*    */   {
/* 73 */     Type base = Navigator.REFLECTION.getBaseClass(this.type, Collection.class);
/* 74 */     if (base == null) {
/* 75 */       return this;
/*    */     }
/* 77 */     return new TypeReference(this.tagName, Navigator.REFLECTION.getTypeArgument(base, 0), new Annotation[0]);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\api\TypeReference.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */