/*    */ package com.sun.xml.bind.v2.model.annotation;
/*    */ 
/*    */ import com.sun.xml.bind.v2.runtime.Location;
/*    */ import java.lang.annotation.Annotation;
/*    */ import java.lang.reflect.InvocationHandler;
/*    */ import java.lang.reflect.InvocationTargetException;
/*    */ import java.lang.reflect.Method;
/*    */ import java.lang.reflect.Proxy;
/*    */ import java.util.HashMap;
/*    */ import java.util.Map;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class LocatableAnnotation
/*    */   implements InvocationHandler, Locatable, Location
/*    */ {
/*    */   private final Annotation core;
/*    */   private final Locatable upstream;
/*    */   
/*    */   public static <A extends Annotation> A create(A annotation, Locatable parentSourcePos)
/*    */   {
/* 28 */     if (annotation == null) return null;
/* 29 */     Class<? extends Annotation> type = annotation.annotationType();
/* 30 */     if (quicks.containsKey(type))
/*    */     {
/* 32 */       return ((Quick)quicks.get(type)).newInstance(parentSourcePos, annotation);
/*    */     }
/*    */     
/*    */ 
/*    */ 
/* 37 */     ClassLoader cl = LocatableAnnotation.class.getClassLoader();
/*    */     try
/*    */     {
/* 40 */       Class loadableT = Class.forName(type.getName(), false, cl);
/* 41 */       if (loadableT != type) {
/* 42 */         return annotation;
/*    */       }
/* 44 */       return (Annotation)Proxy.newProxyInstance(cl, new Class[] { type, Locatable.class }, new LocatableAnnotation(annotation, parentSourcePos));
/*    */     }
/*    */     catch (ClassNotFoundException e) {}
/*    */     
/*    */ 
/* 49 */     return annotation;
/*    */   }
/*    */   
/*    */ 
/*    */   LocatableAnnotation(Annotation core, Locatable upstream)
/*    */   {
/* 55 */     this.core = core;
/* 56 */     this.upstream = upstream;
/*    */   }
/*    */   
/*    */   public Locatable getUpstream() {
/* 60 */     return this.upstream;
/*    */   }
/*    */   
/*    */   public Location getLocation() {
/* 64 */     return this;
/*    */   }
/*    */   
/*    */   public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
/*    */     try {
/* 69 */       if (method.getDeclaringClass() == Locatable.class) {
/* 70 */         return method.invoke(this, args);
/*    */       }
/* 72 */       return method.invoke(this.core, args);
/*    */     } catch (InvocationTargetException e) {
/* 74 */       if (e.getTargetException() != null)
/* 75 */         throw e.getTargetException();
/* 76 */       throw e;
/*    */     }
/*    */   }
/*    */   
/*    */   public String toString() {
/* 81 */     return this.core.toString();
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/* 88 */   private static final Map<Class, Quick> quicks = new HashMap();
/*    */   
/*    */   static {
/* 91 */     for (Quick q : Init.getAll()) {
/* 92 */       quicks.put(q.annotationType(), q);
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\annotation\LocatableAnnotation.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */