/*    */ package net.rubyeye.xmemcached.command.text;
/*    */ 
/*    */ import com.google.code.yanf4j.buffer.IoBuffer;
/*    */ import java.nio.ByteBuffer;
/*    */ import java.util.LinkedList;
/*    */ import java.util.List;
/*    */ import java.util.concurrent.CountDownLatch;
/*    */ import net.rubyeye.xmemcached.command.Command;
/*    */ import net.rubyeye.xmemcached.command.CommandType;
/*    */ import net.rubyeye.xmemcached.impl.MemcachedTCPSession;
/*    */ import net.rubyeye.xmemcached.networking.MemcachedSession;
/*    */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*    */ 
/*    */ public class TextCacheDumpCommand extends Command
/*    */ {
/*    */   public static final String CACHE_DUMP_COMMAND = "stats cachedump %d 0\r\n";
/*    */   private int itemNumber;
/*    */   
/*    */   public final int getItemNumber()
/*    */   {
/* 21 */     return this.itemNumber;
/*    */   }
/*    */   
/*    */   public final void setItemNumber(int itemNumber) {
/* 25 */     this.itemNumber = itemNumber;
/*    */   }
/*    */   
/*    */   public TextCacheDumpCommand(CountDownLatch latch, int itemNumber) {
/* 29 */     super("stats", (byte[])null, latch);
/* 30 */     this.commandType = CommandType.STATS;
/* 31 */     this.result = new LinkedList();
/* 32 */     this.itemNumber = itemNumber;
/*    */   }
/*    */   
/*    */ 
/*    */   public final boolean decode(MemcachedTCPSession session, ByteBuffer buffer)
/*    */   {
/* 38 */     String line = null;
/* 39 */     while ((line = ByteUtils.nextLine(buffer)) != null) {
/* 40 */       if (line.equals("END"))
/* 41 */         return done(session);
/* 42 */       if (line.startsWith("ITEM")) {
/* 43 */         String[] items = line.split(" ");
/* 44 */         ((List)getResult()).add(items[1]);
/*    */       } else {
/* 46 */         return decodeError(line);
/*    */       }
/*    */     }
/* 49 */     return false;
/*    */   }
/*    */   
/*    */   private final boolean done(MemcachedSession session) {
/* 53 */     countDownLatch();
/* 54 */     return true;
/*    */   }
/*    */   
/*    */   public final void encode()
/*    */   {
/* 59 */     String result = String.format("stats cachedump %d 0\r\n", new Object[] { Integer.valueOf(this.itemNumber) });
/* 60 */     this.ioBuffer = IoBuffer.wrap(ByteBuffer.wrap(result.getBytes()));
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\text\TextCacheDumpCommand.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */