/*    */ package org.apache.avro.file;
/*    */ 
/*    */ import java.io.FilterInputStream;
/*    */ import java.io.IOException;
/*    */ import java.io.InputStream;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ class LengthLimitedInputStream
/*    */   extends FilterInputStream
/*    */ {
/*    */   private long remaining;
/*    */   
/*    */   protected LengthLimitedInputStream(InputStream in, long maxLength)
/*    */   {
/* 31 */     super(in);
/* 32 */     this.remaining = maxLength;
/*    */   }
/*    */   
/*    */   public int read() throws IOException
/*    */   {
/* 37 */     if (this.remaining > 0L) {
/* 38 */       int v = super.read();
/* 39 */       if (v != -1) {
/* 40 */         this.remaining -= 1L;
/*    */       }
/* 42 */       return v;
/*    */     }
/* 44 */     return -1;
/*    */   }
/*    */   
/*    */   public int read(byte[] b) throws IOException
/*    */   {
/* 49 */     return read(b, 0, b.length);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   private int remainingInt()
/*    */   {
/* 56 */     return (int)Math.min(this.remaining, 2147483647L);
/*    */   }
/*    */   
/*    */   public int read(byte[] b, int off, int len) throws IOException
/*    */   {
/* 61 */     if (this.remaining == 0L) {
/* 62 */       return -1;
/*    */     }
/* 64 */     if (len > this.remaining) {
/* 65 */       len = remainingInt();
/*    */     }
/* 67 */     int v = super.read(b, off, len);
/* 68 */     if (v != -1) {
/* 69 */       this.remaining -= v;
/*    */     }
/* 71 */     return v;
/*    */   }
/*    */   
/*    */   public int available() throws IOException
/*    */   {
/* 76 */     return Math.min(super.available(), remainingInt());
/*    */   }
/*    */   
/*    */   public long skip(long n) throws IOException
/*    */   {
/* 81 */     long v = super.skip(Math.min(this.remaining, n));
/* 82 */     this.remaining -= v;
/* 83 */     return v;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\file\LengthLimitedInputStream.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */