/*    */ package org.codehaus.jackson.map.ser;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.lang.reflect.Type;
/*    */ import org.codehaus.jackson.JsonGenerationException;
/*    */ import org.codehaus.jackson.JsonGenerator;
/*    */ import org.codehaus.jackson.JsonNode;
/*    */ import org.codehaus.jackson.io.SerializedString;
/*    */ import org.codehaus.jackson.map.AnnotationIntrospector;
/*    */ import org.codehaus.jackson.map.SerializationConfig;
/*    */ import org.codehaus.jackson.map.SerializationConfig.Feature;
/*    */ import org.codehaus.jackson.map.SerializerProvider;
/*    */ import org.codehaus.jackson.map.annotate.JacksonStdImpl;
/*    */ import org.codehaus.jackson.map.introspect.BasicBeanDescription;
/*    */ import org.codehaus.jackson.map.util.EnumValues;
/*    */ import org.codehaus.jackson.node.ArrayNode;
/*    */ import org.codehaus.jackson.node.ObjectNode;
/*    */ import org.codehaus.jackson.type.JavaType;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ @JacksonStdImpl
/*    */ public class EnumSerializer
/*    */   extends ScalarSerializerBase<Enum<?>>
/*    */ {
/*    */   protected final EnumValues _values;
/*    */   
/*    */   public EnumSerializer(EnumValues v)
/*    */   {
/* 36 */     super(Enum.class, false);
/* 37 */     this._values = v;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public static EnumSerializer construct(Class<Enum<?>> enumClass, SerializationConfig config, BasicBeanDescription beanDesc)
/*    */   {
/* 44 */     AnnotationIntrospector intr = config.getAnnotationIntrospector();
/* 45 */     EnumValues v = config.isEnabled(SerializationConfig.Feature.WRITE_ENUMS_USING_TO_STRING) ? EnumValues.constructFromToString(enumClass, intr) : EnumValues.constructFromName(enumClass, intr);
/*    */     
/* 47 */     return new EnumSerializer(v);
/*    */   }
/*    */   
/*    */ 
/*    */   public final void serialize(Enum<?> en, JsonGenerator jgen, SerializerProvider provider)
/*    */     throws IOException, JsonGenerationException
/*    */   {
/* 54 */     jgen.writeString(this._values.serializedValueFor(en));
/*    */   }
/*    */   
/*    */ 
/*    */   public JsonNode getSchema(SerializerProvider provider, Type typeHint)
/*    */   {
/* 60 */     ObjectNode objectNode = createSchemaNode("string", true);
/* 61 */     ArrayNode enumNode; if (typeHint != null) {
/* 62 */       JavaType type = provider.constructType(typeHint);
/* 63 */       if (type.isEnumType()) {
/* 64 */         enumNode = objectNode.putArray("enum");
/* 65 */         for (SerializedString value : this._values.values()) {
/* 66 */           enumNode.add(value.getValue());
/*    */         }
/*    */       }
/*    */     }
/* 70 */     return objectNode;
/*    */   }
/*    */   
/* 73 */   public EnumValues getEnumValues() { return this._values; }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\ser\EnumSerializer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */