/*    */ package org.codehaus.janino.util.iterator;
/*    */ 
/*    */ import java.util.Arrays;
/*    */ import java.util.Collection;
/*    */ import java.util.Enumeration;
/*    */ import java.util.Iterator;
/*    */ import java.util.List;
/*    */ import java.util.NoSuchElementException;
/*    */ import java.util.Stack;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class TraversingIterator
/*    */   implements Iterator
/*    */ {
/* 40 */   private final Stack nest = new Stack();
/* 41 */   private Object nextElement = null;
/* 42 */   private boolean nextElementRead = false;
/*    */   
/*    */   public TraversingIterator(Iterator delegate) {
/* 45 */     this.nest.push(delegate);
/*    */   }
/*    */   
/*    */   public boolean hasNext() {
/* 49 */     return (this.nextElementRead) || (readNext());
/*    */   }
/*    */   
/*    */   public Object next() {
/* 53 */     if ((!this.nextElementRead) && (!readNext())) throw new NoSuchElementException();
/* 54 */     this.nextElementRead = false;
/* 55 */     return this.nextElement;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   private boolean readNext()
/*    */   {
/* 63 */     while (!this.nest.empty()) {
/* 64 */       Iterator it = (Iterator)this.nest.peek();
/* 65 */       if (!it.hasNext()) {
/* 66 */         this.nest.pop();
/*    */       }
/*    */       else {
/* 69 */         Object o = it.next();
/* 70 */         if ((o instanceof Iterator)) {
/* 71 */           this.nest.push(o);
/*    */         }
/* 73 */         else if ((o instanceof Object[])) {
/* 74 */           this.nest.push(Arrays.asList((Object[])o).iterator());
/*    */         }
/* 76 */         else if ((o instanceof Collection)) {
/* 77 */           this.nest.push(((Collection)o).iterator());
/*    */         }
/* 79 */         else if ((o instanceof Enumeration)) {
/* 80 */           this.nest.push(new EnumerationIterator((Enumeration)o));
/*    */         }
/*    */         else {
/* 83 */           this.nextElement = o;
/* 84 */           this.nextElementRead = true;
/* 85 */           return true;
/*    */         }
/*    */       } }
/* 88 */     return false;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public void remove()
/*    */   {
/* 97 */     ((Iterator)this.nest.peek()).remove();
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\util\iterator\TraversingIterator.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */