package prefuse.action.animate;

import java.util.logging.Logger;
import prefuse.action.ItemAction;
import prefuse.util.PrefuseLib;
import prefuse.visual.VisualItem;

public class ArrayAnimator
  extends ItemAction
{
  private static final Logger s_logger = Logger.getLogger(ArrayAnimator.class.getName());
  private String m_field;
  private String m_start;
  private String m_end;
  
  public ArrayAnimator(String paramString1, String paramString2)
  {
    super(paramString1);
    this.m_field = paramString2;
    this.m_start = PrefuseLib.getStartField(paramString2);
    this.m_end = PrefuseLib.getEndField(paramString2);
  }
  
  public void process(VisualItem paramVisualItem, double paramDouble)
  {
    Object localObject1 = paramVisualItem.get(this.m_field);
    Object localObject2;
    Object localObject3;
    Object localObject4;
    if ((localObject1 instanceof float[]))
    {
      localObject2 = (float[])localObject1;
      localObject3 = (float[])paramVisualItem.get(this.m_start);
      localObject4 = (float[])paramVisualItem.get(this.m_end);
      float f = (float)paramDouble;
      for (int j = 0; (j < localObject2.length) && (!Float.isNaN(localObject2[j])); j++) {
        localObject3[j] += f * (localObject4[j] - localObject3[j]);
      }
      paramVisualItem.setValidated(false);
    }
    else if ((localObject1 instanceof double[]))
    {
      localObject2 = (double[])localObject1;
      localObject3 = (double[])paramVisualItem.get(this.m_start);
      localObject4 = (double[])paramVisualItem.get(this.m_end);
      for (int i = 0; (i < localObject2.length) && (!Double.isNaN(localObject2[i])); i++) {
        localObject3[i] += paramDouble * (localObject4[i] - localObject3[i]);
      }
      paramVisualItem.setValidated(false);
    }
    else
    {
      s_logger.warning("Encountered non-double/non-float array type: " + (localObject1 == null ? "null" : localObject1.getClass().getName()));
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\animate\ArrayAnimator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */