package prefuse.action.distortion;

import java.awt.geom.Point2D;
import java.awt.geom.Point2D.Double;
import java.awt.geom.Rectangle2D;
import java.util.Iterator;
import prefuse.Visualization;
import prefuse.action.layout.Layout;
import prefuse.visual.VisualItem;

public abstract class Distortion
  extends Layout
{
  private Point2D m_tmp = new Point2D.Double();
  protected boolean m_distortSize = true;
  protected boolean m_distortX = true;
  protected boolean m_distortY = true;
  
  public Distortion() {}
  
  public Distortion(String paramString)
  {
    super(paramString);
  }
  
  public void setSizeDistorted(boolean paramBoolean)
  {
    this.m_distortSize = paramBoolean;
  }
  
  public boolean isSizeDistorted()
  {
    return this.m_distortSize;
  }
  
  public void run(double paramDouble)
  {
    Rectangle2D localRectangle2D1 = getLayoutBounds();
    Point2D localPoint2D = correct(this.m_anchor, localRectangle2D1);
    Iterator localIterator = getVisualization().visibleItems(this.m_group);
    while (localIterator.hasNext())
    {
      VisualItem localVisualItem = (VisualItem)localIterator.next();
      if (!localVisualItem.isFixed())
      {
        localVisualItem.setX(localVisualItem.getEndX());
        localVisualItem.setY(localVisualItem.getEndY());
        localVisualItem.setSize(localVisualItem.getEndSize());
        if (localPoint2D != null)
        {
          Rectangle2D localRectangle2D2 = localVisualItem.getBounds();
          double d1 = localVisualItem.getX();
          double d2 = localVisualItem.getY();
          if (this.m_distortX) {
            localVisualItem.setX(d1 = distortX(d1, localPoint2D, localRectangle2D1));
          }
          if (this.m_distortY) {
            localVisualItem.setY(d2 = distortY(d2, localPoint2D, localRectangle2D1));
          }
          if (this.m_distortSize)
          {
            double d3 = distortSize(localRectangle2D2, d1, d2, localPoint2D, localRectangle2D1);
            localVisualItem.setSize(d3 * localVisualItem.getSize());
          }
        }
      }
    }
  }
  
  protected Point2D correct(Point2D paramPoint2D, Rectangle2D paramRectangle2D)
  {
    if (paramPoint2D == null) {
      return paramPoint2D;
    }
    double d1 = paramPoint2D.getX();
    double d2 = paramPoint2D.getY();
    double d3 = paramRectangle2D.getMinX();
    double d4 = paramRectangle2D.getMinY();
    double d5 = paramRectangle2D.getMaxX();
    double d6 = paramRectangle2D.getMaxY();
    d1 = d1 > d5 ? d5 : d1 < d3 ? d3 : d1;
    d2 = d2 > d6 ? d6 : d2 < d4 ? d4 : d2;
    this.m_tmp.setLocation(d1, d2);
    return this.m_tmp;
  }
  
  protected abstract double distortX(double paramDouble, Point2D paramPoint2D, Rectangle2D paramRectangle2D);
  
  protected abstract double distortY(double paramDouble, Point2D paramPoint2D, Rectangle2D paramRectangle2D);
  
  protected abstract double distortSize(Rectangle2D paramRectangle2D1, double paramDouble1, double paramDouble2, Point2D paramPoint2D, Rectangle2D paramRectangle2D2);
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\distortion\Distortion.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */