package prefuse.controls;

import java.awt.Component;
import java.awt.Cursor;
import java.awt.event.MouseEvent;
import prefuse.Display;
import prefuse.util.ui.UILib;
import prefuse.visual.VisualItem;

public class PanControl
  extends ControlAdapter
{
  private boolean m_panOverItem;
  private int m_xDown;
  private int m_yDown;
  private int m_button;
  
  public PanControl()
  {
    this(16, false);
  }
  
  public PanControl(boolean paramBoolean)
  {
    this(16, paramBoolean);
  }
  
  public PanControl(int paramInt)
  {
    this(paramInt, false);
  }
  
  public PanControl(int paramInt, boolean paramBoolean)
  {
    this.m_button = paramInt;
    this.m_panOverItem = paramBoolean;
  }
  
  public void mousePressed(MouseEvent paramMouseEvent)
  {
    if (UILib.isButtonPressed(paramMouseEvent, this.m_button))
    {
      paramMouseEvent.getComponent().setCursor(Cursor.getPredefinedCursor(13));
      this.m_xDown = paramMouseEvent.getX();
      this.m_yDown = paramMouseEvent.getY();
    }
  }
  
  public void mouseDragged(MouseEvent paramMouseEvent)
  {
    if (UILib.isButtonPressed(paramMouseEvent, this.m_button))
    {
      Display localDisplay = (Display)paramMouseEvent.getComponent();
      int i = paramMouseEvent.getX();
      int j = paramMouseEvent.getY();
      int k = i - this.m_xDown;
      int m = j - this.m_yDown;
      localDisplay.pan(k, m);
      this.m_xDown = i;
      this.m_yDown = j;
      localDisplay.repaint();
    }
  }
  
  public void mouseReleased(MouseEvent paramMouseEvent)
  {
    if (UILib.isButtonPressed(paramMouseEvent, this.m_button))
    {
      paramMouseEvent.getComponent().setCursor(Cursor.getDefaultCursor());
      this.m_xDown = -1;
      this.m_yDown = -1;
    }
  }
  
  public void itemPressed(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    if (this.m_panOverItem) {
      mousePressed(paramMouseEvent);
    }
  }
  
  public void itemDragged(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    if (this.m_panOverItem) {
      mouseDragged(paramMouseEvent);
    }
  }
  
  public void itemReleased(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    if (this.m_panOverItem) {
      mouseReleased(paramMouseEvent);
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\controls\PanControl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */