package prefuse.controls;

import java.awt.Component;
import java.awt.Cursor;
import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;
import java.awt.geom.Point2D.Float;
import java.io.PrintStream;
import prefuse.Display;
import prefuse.util.ui.UILib;
import prefuse.visual.VisualItem;

public class ZoomControl
  extends AbstractZoomControl
{
  private int yLast;
  private Point2D down = new Point2D.Float();
  private int button = 4;
  
  public ZoomControl() {}
  
  public ZoomControl(int paramInt)
  {
    this.button = paramInt;
  }
  
  public void mousePressed(MouseEvent paramMouseEvent)
  {
    if (UILib.isButtonPressed(paramMouseEvent, this.button))
    {
      Display localDisplay = (Display)paramMouseEvent.getComponent();
      if (localDisplay.isTranformInProgress())
      {
        this.yLast = -1;
        System.err.println("can't move");
        return;
      }
      localDisplay.setCursor(Cursor.getPredefinedCursor(8));
      localDisplay.getAbsoluteCoordinate(paramMouseEvent.getPoint(), this.down);
      this.yLast = paramMouseEvent.getY();
    }
  }
  
  public void mouseDragged(MouseEvent paramMouseEvent)
  {
    if (UILib.isButtonPressed(paramMouseEvent, this.button))
    {
      Display localDisplay = (Display)paramMouseEvent.getComponent();
      if ((localDisplay.isTranformInProgress()) || (this.yLast == -1))
      {
        this.yLast = -1;
        return;
      }
      int i = paramMouseEvent.getY();
      int j = i - this.yLast;
      double d = 1.0D + j / 100.0D;
      int k = zoom(localDisplay, this.down, d, true);
      int m = 8;
      if (k == 3) {
        m = 3;
      }
      localDisplay.setCursor(Cursor.getPredefinedCursor(m));
      this.yLast = i;
    }
  }
  
  public void mouseReleased(MouseEvent paramMouseEvent)
  {
    if (UILib.isButtonPressed(paramMouseEvent, this.button)) {
      paramMouseEvent.getComponent().setCursor(Cursor.getDefaultCursor());
    }
  }
  
  public void itemPressed(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    if (this.m_zoomOverItem) {
      mousePressed(paramMouseEvent);
    }
  }
  
  public void itemDragged(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    if (this.m_zoomOverItem) {
      mouseDragged(paramMouseEvent);
    }
  }
  
  public void itemReleased(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    if (this.m_zoomOverItem) {
      mouseReleased(paramMouseEvent);
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\controls\ZoomControl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */