package prefuse.data.io;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import prefuse.data.Table;
import prefuse.util.io.IOLib;

public abstract class AbstractTableReader
  implements TableReader
{
  public Table readTable(String paramString)
    throws DataIOException
  {
    try
    {
      InputStream localInputStream = IOLib.streamFromString(paramString);
      if (localInputStream == null) {
        throw new DataIOException("Couldn't find " + paramString + ". Not a valid file, URL, or resource locator.");
      }
      return readTable(localInputStream);
    }
    catch (IOException localIOException)
    {
      throw new DataIOException(localIOException);
    }
  }
  
  public Table readTable(URL paramURL)
    throws DataIOException
  {
    try
    {
      return readTable(paramURL.openStream());
    }
    catch (IOException localIOException)
    {
      throw new DataIOException(localIOException);
    }
  }
  
  public Table readTable(File paramFile)
    throws DataIOException
  {
    try
    {
      return readTable(new FileInputStream(paramFile));
    }
    catch (FileNotFoundException localFileNotFoundException)
    {
      throw new DataIOException(localFileNotFoundException);
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\io\AbstractTableReader.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */