package prefuse.util;

public class TypeLib
{
  public static boolean typeCheck(Class paramClass, Object paramObject)
  {
    return (paramClass.isAssignableFrom(paramObject.getClass())) || (isWrapperInstance(paramClass, paramObject));
  }
  
  public static Class getSharedType(Object paramObject1, Object paramObject2)
  {
    return getSharedType(paramObject1.getClass(), paramObject2.getClass());
  }
  
  public static Class getSharedType(Class paramClass1, Class paramClass2)
  {
    if (paramClass1 == paramClass2) {
      return paramClass1;
    }
    if (paramClass1.isAssignableFrom(paramClass2)) {
      return paramClass1;
    }
    if (paramClass2.isAssignableFrom(paramClass1)) {
      return paramClass2;
    }
    return null;
  }
  
  public static boolean isWrapperInstance(Class paramClass, Object paramObject)
  {
    if (!paramClass.isPrimitive()) {
      throw new IllegalArgumentException("Input type must be a primitive");
    }
    if ((Integer.TYPE == paramClass) && ((paramObject instanceof Integer))) {
      return true;
    }
    if ((Long.TYPE == paramClass) && ((paramObject instanceof Long))) {
      return true;
    }
    if ((Float.TYPE == paramClass) && ((paramObject instanceof Float))) {
      return true;
    }
    if ((Double.TYPE == paramClass) && ((paramObject instanceof Double))) {
      return true;
    }
    if ((Boolean.TYPE == paramClass) && ((paramObject instanceof Boolean))) {
      return true;
    }
    if ((Short.TYPE == paramClass) && ((paramObject instanceof Short))) {
      return true;
    }
    if ((Byte.TYPE == paramClass) && ((paramObject instanceof Byte))) {
      return true;
    }
    return (Character.TYPE == paramClass) && ((paramObject instanceof Character));
  }
  
  public static Class getPrimitiveType(Class paramClass)
  {
    if ((Integer.class.equals(paramClass)) || (paramClass == Integer.TYPE)) {
      return Integer.TYPE;
    }
    if ((Long.class.equals(paramClass)) || (paramClass == Long.TYPE)) {
      return Long.TYPE;
    }
    if ((Float.class.equals(paramClass)) || (paramClass == Float.TYPE)) {
      return Float.TYPE;
    }
    if ((Double.class.equals(paramClass)) || (paramClass == Double.TYPE)) {
      return Double.TYPE;
    }
    throw new IllegalArgumentException("Input class must be a numeric type");
  }
  
  public static Class getWrapperType(Class paramClass)
  {
    if (!paramClass.isPrimitive()) {
      return paramClass;
    }
    if (Integer.TYPE == paramClass) {
      return Integer.class;
    }
    if (Long.TYPE == paramClass) {
      return Long.class;
    }
    if (Float.TYPE == paramClass) {
      return Float.class;
    }
    if (Double.TYPE == paramClass) {
      return Double.class;
    }
    if (Boolean.TYPE == paramClass) {
      return Boolean.class;
    }
    if (Short.TYPE == paramClass) {
      return Short.class;
    }
    if (Character.TYPE == paramClass) {
      return Character.class;
    }
    if (Byte.TYPE == paramClass) {
      return Byte.class;
    }
    throw new IllegalArgumentException();
  }
  
  public static boolean isNumericType(Class paramClass)
  {
    return (paramClass == Integer.TYPE) || (paramClass == Long.TYPE) || (paramClass == Double.TYPE) || (paramClass == Float.TYPE);
  }
  
  public static Class getNumericType(Class paramClass1, Class paramClass2)
  {
    if ((!isNumericType(paramClass1)) || (!isNumericType(paramClass2))) {
      throw new IllegalArgumentException("Input types must be primitive number types");
    }
    if ((paramClass1 == Double.TYPE) || (paramClass2 == Double.TYPE)) {
      return Double.TYPE;
    }
    if ((paramClass1 == Float.TYPE) || (paramClass1 == Float.TYPE)) {
      return Float.TYPE;
    }
    if ((paramClass1 == Long.TYPE) || (paramClass2 == Long.TYPE)) {
      return Long.TYPE;
    }
    return Integer.TYPE;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\TypeLib.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */